﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Unity;

namespace FLY.Weight.UI.Client
{
    /// <summary>
    /// Window_Frequency.xaml 的交互逻辑
    /// </summary>
    public partial class WdFrequency : FLY.ControlLibrary.WindowBigClose,INotifyPropertyChanged
    {
        double max = 50;
        double min = 0;

        public event PropertyChangedEventHandler PropertyChanged;

        FLY.Weight.IService.IWeightSystemService weightSystem;
        FLY.Weight.Common.WeighterC weight;
        public WdFrequency()
        {
            InitializeComponent();
            this.DataContext = this;
            this.Closed += WdFrequency_Closed;
        }

        private void WdFrequency_Closed(object sender, EventArgs e)
        {
            this.weight.PropertyChanged -= Weight_PropertyChanged;
        }

        public void Init(
            FLY.Weight.IService.IWeightSystemService weightSystem,
            FLY.Weight.Common.WeighterC weight)
        {
            this.weightSystem = weightSystem;
            this.weight = weight;
            this.DataContext = weight;
            this.grid_weightSystem.DataContext = this.weightSystem;
            this.weight.PropertyChanged += Weight_PropertyChanged;
        }

        private void Weight_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            if (e.PropertyName == nameof(FLY.Weight.Common.WeighterC.ScrewManualFreq)) 
            {
                weight.ScrewManualFreqIsSet = true;
            }
        }

        private void btnPlusClick(object sender, RoutedEventArgs e)
        {
            double freq = weight.ScrewManualFreq + this.weightSystem.ScrewMotorFreqInc;
            freq = Math.Round(freq, 1);

            if (weight.ScrewManualFreq < max) 
            {
                if (freq <= max)
                {
                    weight.ScrewManualFreq = (float)freq;
                    
                }
                else if(freq > max)
                {
                    weight.ScrewManualFreq = (float)max;
                }
            }

        }

        private void btnMinusClick(object sender, RoutedEventArgs e)
        {
            double freq = weight.ScrewManualFreq - this.weightSystem.ScrewMotorFreqInc;
            freq = Math.Round(freq, 1);

            if (weight.ScrewManualFreq > min)
            {
                if (freq >= min)
                {
                    weight.ScrewManualFreq = (float)freq;
                }
                else if (freq < min)
                {
                    weight.ScrewManualFreq = (float)min;
                }
            }
        }
    }
}
