﻿using FLY.OBJComponents.IService;
using FLY.Weight.IService;
using FLY.Weight.Server.Model;
using FObjBase;
using FObjBase.Reflect;
using System;

namespace FLY.Weight.Client
{
    public class BulkDbFlowServiceClient : FObjBase.Reflect.Reflect_SeviceClient, IBulkDbFlowService
    {
        protected override Type InterfaceType => typeof(IBulkDbFlowService);

        public BulkDbFlowServiceClient(UInt32 id) : base(id) { }

        public BulkDbFlowServiceClient(UInt32 serviceId, string connName) : base(serviceId, connName) { }


        #region IBulkDBService
        /// <summary>
        /// 最后一条数据Id
        /// </summary>
        public long LastId { get; set; } = -1;

        /// <summary>
        /// 获取纵向趋势图
        /// </summary>
        /// <param name="request"></param>
        /// <param name="asyncDelegate"></param>
        /// <param name="asyncContext"></param>
        [Call(typeof(Pack_GetTrendReponse<Lc_Flow>))]
        public void GetTrend(
            Pack_GetTrendRequest request,
            AsyncCBHandler asyncDelegate, object asyncContext)
        {
            Call(nameof(GetTrend), new { request }, asyncDelegate, asyncContext);
        }
        #endregion


    }
}
