﻿using FLY.OBJComponents.IService;
using FLY.Weight.IService;
using FLY.Weight.Server.Model;
using FObjBase;
using FObjBase.Reflect;
using System;

namespace FLY.Weight.Client
{
    public class BulkDbMixServiceClient : FObjBase.Reflect.Reflect_SeviceClient, IBulkDbMixService
    {
        protected override Type InterfaceType => typeof(IBulkDbMixService);

        public BulkDbMixServiceClient(UInt32 id) : base(id) { }

        public BulkDbMixServiceClient(UInt32 serviceId, string connName) : base(serviceId, connName) { }


        #region IBulkDBService
        /// <summary>
        /// 最后一条数据Id
        /// </summary>
        public long LastId { get; set; } = -1;
        public int Index { get; set; }
        /// <summary>
        /// 获取纵向趋势图
        /// </summary>
        /// <param name="request"></param>
        /// <param name="asyncDelegate"></param>
        /// <param name="asyncContext"></param>
        [Call(typeof(Pack_GetTrendReponse<Lc_Mix>))]
        public void GetTrend(
            Pack_GetTrendRequest request,
            AsyncCBHandler asyncDelegate, object asyncContext)
        {
            Call(nameof(GetTrend), new { request }, asyncDelegate, asyncContext);
        }
        #endregion


    }
}
